/*
<:copyright-broadcom 
 
 Copyright (c) 2002 Broadcom Corporation 
 All Rights Reserved 
 No portions of this material may be reproduced in any form without the 
 written permission of: 
          Broadcom Corporation 
          16215 Alton Parkway 
          Irvine, California 92619 
 All information contained in this document is Broadcom Corporation 
 company private, proprietary, and trade secret. 
 
:>
*/
/****************************************************************************
 *
 * AdslCoreMap.h -- Definitions for ADSL core hardware
 *
 * Description:
 *	Definitions for ADSL core hardware
 *
 *
 * Authors: Ilya Stomakhin
 *
 * $Revision: 1.1 $
 *
 * $Id: AdslCoreMap.h,v 1.1 2004/04/08 21:24:49 ilyas Exp $
 *
 * $Log: AdslCoreMap.h,v $
 * Revision 1.1  2004/04/08 21:24:49  ilyas
 * Initial CVS checkin. Version A2p014
 *
 ****************************************************************************/

#define RCVINT_BIT              0x00010000
#define XMTINT_BIT              0x01000000
#define MSGINT_BIT              0x00000020

#if defined(__KERNEL__)
#include <linux/config.h>
#endif
#include "softdsl/AdslCoreDefs.h"

#if defined(CONFIG_BCM96348) || defined(CONFIG_BCM96358)
#define ADSL_ENUM_BASE          0xFFFE3000
#elif defined(CONFIG_BCM96338)
#define ADSL_ENUM_BASE          0xFFFE1000
#else
#error  No definition for ADSL_ENUM_BASE
#endif

#if defined(CONFIG_BCM96358)
#define ATM_REG_BASE			0xFFFE2000
#else
#define ATM_REG_BASE			0xFFFE4000
#endif

#define ADSL_LMEM_BASE          0xFFF00000

#ifndef FLATTEN_ADDR_ADJUST
#define FLATTEN_ADDR_ADJUST		ADSL_LMEM_BASE
#endif

/* Backplane Enumeration Space Addresses */

#define ADSL_CTL                (0x000 / 4)
#define ADSL_STATUS             (0x004 / 4)
#define ADSL_INTMASK_I          (0x024 / 4)
#define ADSL_INTMASK_F          (0x02c / 4)
#define ADSL_INTSTATUS_I        (0x020 / 4)
#define ADSL_INTSTATUS_F        (0x028 / 4)
#define ADSL_HOSTMESSAGE        (0x300 / 4)

/* DMA Regs, offset from backplane enumeration space address */

#define XMT_CTL_INTR            (0x200 / 4)
#define XMT_ADDR_INTR           (0x204 / 4)
#define XMT_PTR_INTR            (0x208 / 4)
#define XMT_STATUS_INTR         (0x20c / 4)
#define RCV_CTL_INTR            (0x210 / 4)
#define RCV_ADDR_INTR           (0x214 / 4)
#define RCV_PTR_INTR            (0x218 / 4)
#define RCV_STATUS_INTR         (0x21c / 4)
#define XMT_CTL_FAST            (0x220 / 4)
#define XMT_ADDR_FAST           (0x224 / 4)
#define XMT_PTR_FAST            (0x228 / 4)
#define XMT_STATUS_FAST         (0x22c / 4)
#define RCV_CTL_FAST            (0x230 / 4)
#define RCV_ADDR_FAST           (0x234 / 4)
#define RCV_PTR_FAST            (0x238 / 4)
#define RCV_STATUS_FAST         (0x23c / 4)

#define ADSL_CORE_RESET         (0xf98 / 4)
#define ADSL_MIPS_RESET         (0x000 / 4)

#define US_DESCR_TABLE_ADDR		0xA0004000
#define DS_DESCR_TABLE_ADDR		0xA0005000
#define DS_STATUS_SIZE			16

#define HDMA_INIT_FLAG_ADDR		0xA0006000
#define US_CURR_DSCR_ADDR		0xA0006004
#define US_LAST_DSCR_ADDR		0xA0006008
#define DS_CURR_DSCR_ADDR		0xA000600c
#define DS_LAST_DSCR_ADDR		0xA0006010
